The package for this problem was not updated by the problem writer or Codeforces administration after we've upgraded the judging servers. To adjust the time limit constraint, a solution execution time will be multiplied by 2. For example, if your solution works for 400 ms on judging servers, then the value 800 ms will be displayed and used to determine the verdict.

Codeforces Round 190 (Div. 1) |
---|

Finished |

Virtual contest is a way to take part in past contest, as close as possible to participation on time. It is supported only ICPC mode for virtual contests.
If you've seen these problems, a virtual contest is not for you - solve these problems in the archive.
If you just want to solve some problem from a contest, a virtual contest is not for you - solve this problem in the archive.
Never use someone else's code, read the tutorials or communicate with other person during a virtual contest.

data structures

divide and conquer

dp

*2600

No tag edit access

The problem statement has recently been changed. View the changes.

×
E. Ciel and Gondolas

time limit per test

4 secondsmemory limit per test

512 megabytesinput

standard inputoutput

standard outputFox Ciel is in the Amusement Park. And now she is in a queue in front of the Ferris wheel. There are *n* people (or foxes more precisely) in the queue: we use first people to refer one at the head of the queue, and *n*-th people to refer the last one in the queue.

There will be *k* gondolas, and the way we allocate gondolas looks like this:

- When the first gondolas come, the
*q*_{1}people in head of the queue go into the gondolas. - Then when the second gondolas come, the
*q*_{2}people in head of the remain queue go into the gondolas....

- The remain
*q*_{k}people go into the last (*k*-th) gondolas.

Note that *q*_{1}, *q*_{2}, ..., *q*_{k} must be positive. You can get from the statement that and *q*_{i} > 0.

You know, people don't want to stay with strangers in the gondolas, so your task is to find an optimal allocation way (that is find an optimal sequence *q*) to make people happy. For every pair of people *i* and *j*, there exists a value *u*_{ij} denotes a level of unfamiliar. You can assume *u*_{ij} = *u*_{ji} for all *i*, *j* (1 ≤ *i*, *j* ≤ *n*) and *u*_{ii} = 0 for all *i* (1 ≤ *i* ≤ *n*). Then an unfamiliar value of a gondolas is the sum of the levels of unfamiliar between any pair of people that is into the gondolas.

A total unfamiliar value is the sum of unfamiliar values for all gondolas. Help Fox Ciel to find the minimal possible total unfamiliar value for some optimal allocation.

Input

The first line contains two integers *n* and *k* (1 ≤ *n* ≤ 4000 and 1 ≤ *k* ≤ *min*(*n*, 800)) — the number of people in the queue and the number of gondolas. Each of the following *n* lines contains *n* integers — matrix *u*, (0 ≤ *u*_{ij} ≤ 9, *u*_{ij} = *u*_{ji} and *u*_{ii} = 0).

Please, use fast input methods (for example, please use BufferedReader instead of Scanner for Java).

Output

Print an integer — the minimal possible total unfamiliar value.

Examples

Input

5 2

0 0 1 1 1

0 0 1 1 1

1 1 0 0 0

1 1 0 0 0

1 1 0 0 0

Output

0

Input

8 3

0 1 1 1 1 1 1 1

1 0 1 1 1 1 1 1

1 1 0 1 1 1 1 1

1 1 1 0 1 1 1 1

1 1 1 1 0 1 1 1

1 1 1 1 1 0 1 1

1 1 1 1 1 1 0 1

1 1 1 1 1 1 1 0

Output

7

Input

3 2

0 2 0

2 0 3

0 3 0

Output

2

Note

In the first example, we can allocate people like this: {1, 2} goes into a gondolas, {3, 4, 5} goes into another gondolas.

In the second example, an optimal solution is : {1, 2, 3} | {4, 5, 6} | {7, 8}.

Codeforces (c) Copyright 2010-2024 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Apr/24/2024 20:57:36 (k2).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|